string GetDemoInfoDialog() {
	return """
	<frame scale="1.12">
	<quad size="240.75 140"  opacity="0.7" halign="center" style="UICommon128_1" substyle="BgDialog" valign="center" z-index="-1"/>
	<quad size="240.75 12"  halign="center" style="UICommon128_1" substyle="BgDialogTitle" pos="0 70"/>
	<label pos="0 66" z-index="2" size="200 5" text="Want more?" textfont="GameFontExtraBold" halign="center" textsize="4" style="TextTitle3"/>
	<label pos="0 55" z-index="0" size="230 5" text="Currently, you are running a DEMO PREVIEW version of the titlepack. There is quite some work to do still. " textfont="GameFontRegular" halign="center"/>
	<quad pos="0 48" z-index="1" size="240 60" image="file://Media/Images/TMNextPlatform/PlatformBackground.jpg" keepratio="Clip" halign="center"/>
	
	<label pos="0 -15" z-index="0" size="230 5" text="Mappers needed!" textfont="GameFontExtraBold" halign="center" textsize="4" style="TextTitle3"/>
	<label pos="-115 -22" z-index="0" size="230 5" text="We need YOU to build a few maps for the campaign. If you join us you will be able to:" textfont="GameFontRegular"/>
	<frame pos="-110 0" >
		<label pos="-0 -28" z-index="0" size="80 5" text="- Editors: Build a platform map" textfont="GameFontRegular"/>
		<label pos="-0 -34" z-index="0" size="80 5" text="- Local: Play any platform map you like" textfont="GameFontRegular"/>
		<label pos="-0 -40" z-index="0" size="80 5" text="- Campaign: Test new campaign maps" textfont="GameFontRegular"/>
		<label pos="-0 -46" z-index="0" size="80 5" text="- Decide on changes" textfont="GameFontRegular"/>
	</frame>
	<frame pos="0 -48">
		<quad pos="0 0" z-index="1" size="12 12" image="file://Media/Images/TMNextPlatform/Icon/discord.png" halign="center" opacity=".9"/>
		<label pos="0 -9" z-index="2" size="80 30" substyle="BgPlayerCardBig" style="CardButtonMediumXXXL" url="https://discord.gg/6xJwQebZGr" text="Join testers on our Discord Server" scale="1.2" halign="center"/>
	</frame>
	<label pos="94 -57" z-index="1" text="Close" halign="center" style="CardButtonMedium" scriptevents="1" translate="1" id="HideDialogButton" scale="1.1"/>
</frame>

<script><!-- 
main()	{
	EnableMenuNavigation(True, True, Page.GetFirstChild("HideDialogButton"), 1);
	Audio.PlaySoundEvent(CAudioManager::ELibSound::ShowDialog , 1, 1.);
	while(True)	{
		yield;
		foreach(Event, PendingEvents) {
			if (Event.Type == CMlEvent::Type::MouseClick)	{
				if(Event.ControlId == "HideDialogButton")	{
					SendCustomEvent("MLHook_menu_action", ["hide_demo_dialog"]);
				}
			}
		}
	}			
}
--></script>
	""";
}

string GetTesterCheckUI() {
	return """
	<label pos="150 80" z-index="0" size="80 5" text="Verifying tester..." halign="right" textfont="GameFontRegular" textsize="2" valign="center" style="TextButtonBig" id="StatusLabel" textemboss="1"/>
<script><!--

Void SetMessage(Text Message) {
	(Page.GetFirstChild("StatusLabel") as CMlLabel).SetText(Message);
}

main()	{
		declare persistent Boolean Persistent_IsPlatformTester for LocalUser;
		declare Text[] AllowedUsers;
		declare Loop = True;
		declare ApiFound = False;
		
		Persistent_IsPlatformTester = False;
		sleep(200);
		Http.CreateGet("https://raw.githubusercontent.com/ArkadySK/TMNextPlatform/main/whitelist.json", False);
		while (Loop) {
			yield;
			
			foreach (Hevent in Http.PendingEvents) {
				declare req <=> Hevent.Request;
				
				if (req.IsCompleted) {
					if (req.StatusCode != 200) {
						SetMessage("Request failed");
						Http.Destroy(Hevent.Request);
						break;
					}
						
					AllowedUsers.fromjson(req.Result);
					foreach (user in AllowedUsers) {
						if (LocalUser.Name == user) { 
							ApiFound = True;
						}
					}
					Http.Destroy(Hevent.Request);
					Loop=False;
						
				}
			}
		}
		
		if (!ApiFound) {	
			SetMessage("Welcome demo player!");
			Persistent_IsPlatformTester = False;
		}
		else	{
			SetMessage("Welcome tester!");
			Persistent_IsPlatformTester = True;			
		}
}

--></script>
""";
}

string GetEnterTitlepackButton() {
    return """ 
<frame id="EnterPlatformFrame" scale=".67" pos="0 73" z-index="-9.9">
	<quad id="ButtonEnterTitlepack" size="120 20" halign="center" style="UICommon128_1" substyle="BgFrameTilted1" modulatecolor="18925EFF" valign="center" scriptevents="1"/>
	<label id="EnterLabel" size="110 20" text="Enter Platform!" style="TextButtonBig" translate="1" halign="center" textsize="7" textfont="GameFontExtraBold" pos="0 1" valign="center" textcolor="A8EFB0FF" opacity=".9"/>
</frame>

<script><!--
main()	{
	declare EnterTPSound = Audio.CreateSound("https://raw.githubusercontent.com/ArkadySK/TMNextPlatform/main/Audio/ManiaPlanetEnterTitle.ogg");
	declare button = (Page.GetFirstChild("ButtonEnterTitlepack") as CMlQuad);
	declare buttonText = (Page.GetFirstChild("EnterLabel") as CMlLabel);
	declare persistent Boolean Persistent_HideEnterPlatform for LocalUser;
	if(Persistent_HideEnterPlatform){
		Page.GetFirstChild("EnterPlatformFrame").Hide();
		return;
	}
	while(True) {
		yield;
		
		foreach(Event, PendingEvents) {
			if(Event.ControlId == "ButtonEnterTitlepack")	{
				if (Event.Type ==  CMlEvent::Type::MouseOver)	{
					Audio.PlaySoundEvent(CAudioManager::ELibSound::Valid , 1, 1.);
					AnimMgr.Add(button, "<quad modulatecolor='000000' />", 200, CAnimManager::EAnimManagerEasing::SineOut);
					AnimMgr.Add(buttonText, "<label textcolor='FFFFFF' />", 200, CAnimManager::EAnimManagerEasing::Linear);
				}
				if (Event.Type ==  CMlEvent::Type::MouseOut)	{
					AnimMgr.Add(button, "<quad modulatecolor='18925EFF' />", 150, CAnimManager::EAnimManagerEasing::Linear);	
					AnimMgr.Add(buttonText, "<label textcolor='A8EFB0FF' />", 150, CAnimManager::EAnimManagerEasing::Linear);
				}
				if (Event.Type ==  CMlEvent::Type::MouseClick)	{
					SendCustomEvent("MLHook_menu_action", ["enter_titlepack"]);
					wait(EnterTPSound != Null);
					Audio.PlaySoundEvent(EnterTPSound, 1., 0);
				}
			}
		}
	}
}
--></script>
	""";
}

string GetMenuBackground() {
    return """ <quad pos="-160 90" z-index="-99" size="320 180" image="file://Media/Images/TMNextPlatform/Background/MenuBg.webm"/> 
	<script><!--
#Include "TimeLib" as TimeLib
main() 
{
	declare Ready = False;
	declare Music = Audio.CreateSound("file://Media/Musics/TMNextPlatform/BlurredMemories.ogg", 1.0, True, True, False); 
	if (Music != Null && Music.DownloadInProgress == False) 	{
		if (Ready == False)	 {
		Ready = True;
		Music.Play();
		} 
	}
}
--></script>
""";
}

string GetMenuLoadscreen() {
	return """
    <quad pos="-160 90" z-index="-99" size="320 180" image="file://Media/Images/TMNextPlatform/Background/MenuBg.webm"/> 
    <label z-index="0" text="Please wait..." translate="1" valign="center2" pos="136 -66" textfont="GameFontSemiBold" textsize="7" size="100 6" halign="right" style="TextTitle3"/>
    """;
}

string LoadscreenText(string text) {
	text = "\"" + text + "\"";
	return """<manialink version="3">
<frame id="LockFrame" z-index="90">	
	<quad style="Bgs1" substyle="BgCardProperty" posn="0 6" sizen="150 12" z-index="-5" halign="center"/>
	<quad style="Bgs1InRace" substyle="BgGlow2" posn="0 11" sizen="156.4 8.2" z-index="1" halign="center"/>	
	<quad style="Bgs1" substyle="BgMetalBar" posn="0 -6" sizen="150 2" halign="center"/>		
	<label text=""" + text + """ z-index="3" size="157 5" valign="center" halign="center" pos="0 0" translate="1" autonewline="1" style="TextCardMedium" textsize="2.5"/>
	<quad pos="0 0" z-index="0" size="400 200" halign="center" valign="center" scriptevents="1" style="Bgs1" substyle="BgEmpty"/>
</frame>
</manialink>""";
}

string GetUpdateDialog() {
	return """
	<frame z-index="1">
       <label pos="-60 4" z-index="0" size="120 10" text="You're currently running an old version of the titlepack. You should update to enjoy all the new features. Update?" halign="left" autonewline="1" textsize="2" textfont="GameFontRegular"/>
       <label pos="0 12" z-index=".1" size="130 7" halign="center" valign="center" style="TextTitle3"
              text="TM2020 - Platform: Update Available" translate="1"/>
       <label id="UpdateButton" pos="-60 -11" z-index=".2" size="35 7" valign="center" style="CardButtonMedium"
              scriptevents="1" text="Update"/>
       <label id="IgnoreButton" pos="0 -11" z-index=".2" size="35 7" valign="center" style="CardButtonMedium"
              scriptevents="1" text="Ignore" halign="center"/>
       <label id="ExitButton" pos="60 -11" z-index=".2" size="35 7" halign="right" valign="center" style="CardButtonMedium"
              scriptevents="1" text="Exit"/>
</frame>
<quad size="130 10" halign="center" valign="center" style="UICommon128_1" substyle="BgDialogTitle" pos="0 12" z-index="1"/>
<quad size="130 34" halign="center" valign="center" style="UICommon128_1" substyle="BgDialog" pos="0"/>

<script><!-- 
main()	{
	Audio.PlaySoundEvent(CAudioManager::ELibSound::ShowDialog , 1, 1.);
	while(True)	{
		yield;
		foreach(Event, PendingEvents) {
			if (Event.Type ==  CMlEvent::Type::MouseClick)	{
				if(Event.ControlId != "") {
					Audio.PlaySoundEvent(CAudioManager::ELibSound::HideDialog , 1, 1.);
                }
                if(Event.ControlId == "UpdateButton")	{
					SendCustomEvent("MLHook_menu_action", ["update_dialog_update"]);
				}
				else if(Event.ControlId == "IgnoreButton")	{
					SendCustomEvent("MLHook_menu_action", ["update_dialog_ignore"]);
				}
				else if(Event.ControlId == "ExitButton")	{
					SendCustomEvent("MLHook_menu_action", ["hide_demo_exit"]);
				}
			}
		}
	}			
}
--></script>
        
	""";
}